using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using RMYY_CallCenter_Api.DB;

namespace RMYY_CallCenter_Api.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_DictDrug
    /// </summary>
    public partial class T_Sys_DictDrug
    {
        public T_Sys_DictDrug()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_ID", "T_Sys_DictDrug");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_DictDrug");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(RMYY_CallCenter_Api.Model.T_Sys_DictDrug model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_DictDrug(");
            strSql.Append("F_DictDrugid,cDgDispCode,cDgName,cDgNameCode,cDgGeneralName,cDgSpecification,iDgMaxstock,iDgMinstock,cDgDescription,iDgStdPrice,iDgLocalStdPrice,F_CreateTime,F_IsDelete,cManufacturer,iRetail)");
            strSql.Append(" values (");
            strSql.Append("@F_DictDrugid,@cDgDispCode,@cDgName,@cDgNameCode,@cDgGeneralName,@cDgSpecification,@iDgMaxstock,@iDgMinstock,@cDgDescription,@iDgStdPrice,@iDgLocalStdPrice,@F_CreateTime,@F_IsDelete,@cManufacturer,@iRetail)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DictDrugid", SqlDbType.Int,4),
                    new SqlParameter("@cDgDispCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@cDgName", SqlDbType.NVarChar,50),
                    new SqlParameter("@cDgNameCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@cDgGeneralName", SqlDbType.NVarChar,50),
                    new SqlParameter("@cDgSpecification", SqlDbType.NVarChar,50),
                    new SqlParameter("@iDgMaxstock", SqlDbType.Decimal,9),
                    new SqlParameter("@iDgMinstock", SqlDbType.Decimal,9),
                    new SqlParameter("@cDgDescription", SqlDbType.NVarChar,-1),
                    new SqlParameter("@iDgStdPrice", SqlDbType.Decimal,9),
                    new SqlParameter("@iDgLocalStdPrice", SqlDbType.Decimal,9),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                   new SqlParameter("@cManufacturer", SqlDbType.VarChar,200),
                    new SqlParameter("@iRetail", SqlDbType.Decimal ,9)};

          
            parameters[0].Value = model.F_DictDrugid;
            parameters[1].Value = model.cDgDispCode;
            parameters[2].Value = model.cDgName;
            parameters[3].Value = model.cDgNameCode;
            parameters[4].Value = model.cDgGeneralName;
            parameters[5].Value = model.cDgSpecification;
            parameters[6].Value = model.iDgMaxstock;
            parameters[7].Value = model.iDgMinstock;
            parameters[8].Value = model.cDgDescription;
            parameters[9].Value = model.iDgStdPrice;
            parameters[10].Value = model.iDgLocalStdPrice;
            parameters[11].Value = model.F_CreateTime;
            parameters[12].Value = model.F_IsDelete;
            parameters[13].Value = model.cManufacturer;
            parameters[14].Value = model.iRetail;
             
            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(RMYY_CallCenter_Api.Model.T_Sys_DictDrug model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_DictDrug set ");
            strSql.Append("F_DictDrugid=@F_DictDrugid,");
            strSql.Append("cDgDispCode=@cDgDispCode,");
            strSql.Append("cDgName=@cDgName,");
            strSql.Append("cDgNameCode=@cDgNameCode,");
            strSql.Append("cDgGeneralName=@cDgGeneralName,");
            strSql.Append("cDgSpecification=@cDgSpecification,");
            strSql.Append("iDgMaxstock=@iDgMaxstock,");
            strSql.Append("iDgMinstock=@iDgMinstock,");
            strSql.Append("cDgDescription=@cDgDescription,");
            strSql.Append("iDgStdPrice=@iDgStdPrice,");
            strSql.Append("iDgLocalStdPrice=@iDgLocalStdPrice,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_IsDelete=@F_IsDelete,");
            strSql.Append("cManufacturer=@cManufacturer,");
            strSql.Append("iRetail=@iRetail");
            
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_DictDrugid", SqlDbType.Int,4),
                    new SqlParameter("@cDgDispCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@cDgName", SqlDbType.NVarChar,50),
                    new SqlParameter("@cDgNameCode", SqlDbType.NVarChar,50),
                    new SqlParameter("@cDgGeneralName", SqlDbType.NVarChar,50),
                    new SqlParameter("@cDgSpecification", SqlDbType.NVarChar,50),
                    new SqlParameter("@iDgMaxstock", SqlDbType.Decimal,9),
                    new SqlParameter("@iDgMinstock", SqlDbType.Decimal,9),
                    new SqlParameter("@cDgDescription", SqlDbType.NVarChar,-1),
                    new SqlParameter("@iDgStdPrice", SqlDbType.Decimal,9),
                    new SqlParameter("@iDgLocalStdPrice", SqlDbType.Decimal,9),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                     new SqlParameter("@cManufacturer", SqlDbType.VarChar,200),
                    new SqlParameter("@iRetail", SqlDbType.Decimal ,9),
                    
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_DictDrugid;
            parameters[1].Value = model.cDgDispCode;
            parameters[2].Value = model.cDgName;
            parameters[3].Value = model.cDgNameCode;
            parameters[4].Value = model.cDgGeneralName;
            parameters[5].Value = model.cDgSpecification;
            parameters[6].Value = model.iDgMaxstock;
            parameters[7].Value = model.iDgMinstock;
            parameters[8].Value = model.cDgDescription;
            parameters[9].Value = model.iDgStdPrice;
            parameters[10].Value = model.iDgLocalStdPrice;
            parameters[11].Value = model.F_CreateTime;
            parameters[12].Value = model.F_IsDelete;
            parameters[13].Value = model.cManufacturer;
            parameters[14].Value = model.iRetail;
            
            parameters[15].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_DictDrug ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_DictDrug ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Sys_DictDrug GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_ID,F_DictDrugid ,cManufacturer,iRetail,cDgDispCode,cDgName,cDgNameCode,cDgGeneralName,cDgSpecification,iDgMaxstock,iDgMinstock,cDgDescription,iDgStdPrice,iDgLocalStdPrice,F_CreateTime,F_IsDelete from T_Sys_DictDrug ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            RMYY_CallCenter_Api.Model.T_Sys_DictDrug model = new RMYY_CallCenter_Api.Model.T_Sys_DictDrug();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public RMYY_CallCenter_Api.Model.T_Sys_DictDrug DataRowToModel(DataRow row)
        {
            RMYY_CallCenter_Api.Model.T_Sys_DictDrug model = new RMYY_CallCenter_Api.Model.T_Sys_DictDrug();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["F_DictDrugid"] != null && row["F_DictDrugid"].ToString() != "")
                {
                    model.F_DictDrugid = int.Parse(row["F_DictDrugid"].ToString());
                }
                if (row["cDgDispCode"] != null)
                {
                    model.cDgDispCode = row["cDgDispCode"].ToString();
                }
                if (row["cDgName"] != null)
                {
                    model.cDgName = row["cDgName"].ToString();
                }
                if (row["cDgNameCode"] != null)
                {
                    model.cDgNameCode = row["cDgNameCode"].ToString();
                }
                if (row["cDgGeneralName"] != null)
                {
                    model.cDgGeneralName = row["cDgGeneralName"].ToString();
                }
                if (row["cDgSpecification"] != null)
                {
                    model.cDgSpecification = row["cDgSpecification"].ToString();
                }
                if (row["iDgMaxstock"] != null && row["iDgMaxstock"].ToString() != "")
                {
                    model.iDgMaxstock = decimal.Parse(row["iDgMaxstock"].ToString());
                }
                if (row["iDgMinstock"] != null && row["iDgMinstock"].ToString() != "")
                {
                    model.iDgMinstock = decimal.Parse(row["iDgMinstock"].ToString());
                }
                if (row["cDgDescription"] != null)
                {
                    model.cDgDescription = row["cDgDescription"].ToString();
                }
                if (row["iDgStdPrice"] != null && row["iDgStdPrice"].ToString() != "")
                {
                    model.iDgStdPrice = decimal.Parse(row["iDgStdPrice"].ToString());
                }
                if (row["iDgLocalStdPrice"] != null && row["iDgLocalStdPrice"].ToString() != "")
                {
                    model.iDgLocalStdPrice = decimal.Parse(row["iDgLocalStdPrice"].ToString());
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["iRetail"] != null && row["iRetail"].ToString() != "")
                {
                    model.iRetail = decimal.Parse(row["iRetail"].ToString());
                }
                if (row["cManufacturer"] != null)
                {
                    model.cManufacturer = row["cManufacturer"].ToString();
                }

                 
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_ID,F_DictDrugid,cManufacturer,iRetail,cDgDispCode,cDgName,cDgNameCode,cDgGeneralName,cDgSpecification,iDgMaxstock,iDgMinstock,cDgDescription,iDgStdPrice,iDgLocalStdPrice,F_CreateTime,F_IsDelete ");
            strSql.Append(" FROM T_Sys_DictDrug ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_ID,F_DictDrugid,cManufacturer,iRetail,cDgDispCode,cDgName,cDgNameCode,cDgGeneralName,cDgSpecification,iDgMaxstock,iDgMinstock,cDgDescription,iDgStdPrice,iDgLocalStdPrice,F_CreateTime,F_IsDelete ");
            strSql.Append(" FROM T_Sys_DictDrug ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_DictDrug ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_DictDrug T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Sys_DictDrug";
			parameters[1].Value = "F_ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
